program Add;
{$APPTYPE CONSOLE}
uses
  CakDir,
  Classes,
  SysUtils,
  Controls;
const ver = '0.2';
      lastedit = '05/16/2001';
      fmtstr = '%-14s %-18s %-10s %-10s %-20s';
type
  TControl1 = class(TControl)
  private
    { Private declarations }
  public
  procedure CakDir1CMessage(Sender: TObject; ErrCode: Integer; Message: String);
  procedure CakDir1CProgress(Sender: TObject; Filename: String; FileSize, Completed: Integer);
  procedure CakDir1COverwrite( Sender : TObject; Filename : string;var overwrite : boolean ;var applytoall : boolean);
  procedure CakDir1CPassword( Sender : TObject; filename : string; var newpassword : string);
    { Public declarations }
  end;

var control1 : Tcontrol1;
procedure TControl1.CakDir1CPassword( Sender : TObject; filename : string; var newpassword : string);
begin
Write('Please enter the password of ' + Filename );
readln(newpassword);
end;

procedure TControl1.CakDir1COverwrite( Sender : TObject; Filename : string;var overwrite : boolean ;var applytoall : boolean);
var c : char;
begin
c := '-';
while (c <> 'Y') and (c <> 'N') and (c <> 'A') and (c <> 'C') do
begin
Writeln('Do you want to overwrite ' + Filename + '(Yes/No/All/Cancel)');
Readln(c);
applytoall := false;
case c of
'Y' : overwrite := true;
'N' : overwrite := false;
'A' : begin overwrite := true; applytoall := true; end;
'C' : begin overwrite := false; applytoall := true; end;
end;
end;

end;

procedure TControl1.CakDir1CMessage(Sender: TObject; ErrCode: Integer; Message: String);
begin
        Writeln(Message);
end;
procedure TControl1.CakDir1CProgress(Sender: TObject; Filename: String;  FileSize, Completed: Integer);
begin
        Write('.');
end;

procedure DisplayHelp;
var k : string;
    x : supporttype;
    CakDir1 : TCakDir;
begin
          CakDir1 := TCakDir.Create(nil);
          for x := _ZIP to _WIT do
                if cakdir1.CanDo(x,_Add) then
                        if x <> _AKS then
                        if k = '' then
                        k := k + cakdir1.GetarcStringFull(x) else
                        k := k + ',' + cakdir1.GetarcStringFull(x);
          CakDir1.free;

          Writeln('Usage : add.exe /[a/r] [sd] <Archive name> <File2Add>');
          Writeln('Archive supported :' + k);
          Writeln('e.g. Add /r c:\demo.zip *.txt ');
          Writeln('e.g. Add /asd c:\demo.zip c:\temp\*.*');
          Writeln;
          Writeln('/? = display this help');
          Writeln('/a = add');
          Writeln('/r = remove(delete)');
          Writeln('s = include subdirectory');
          Writeln('d = save directory information');
          Writeln;
end;

function ProcessParam: boolean;
var
  c:       char;
  option:     string;
  Path:    String;
  param1,param2,param3 : string;
  handled: boolean;
  CakDir1 : TCakDir;
begin
  if (ParamStr(1)[1] <> '/') or (fileexists(Paramstr(1))) then
  begin
    Result := False;
    exit;
  end;

  CakDir1 := TCakDir.Create(nil);
  CakDir1.OnCMessage := control1.CakDir1CMessage;
  CakDir1.OnCProgress := Control1.CakDir1CProgress;
  CakDir1.OnCOverwrite := Control1.CakDir1COverwrite;
  CakDir1.OnCPassword := Control1.CakDir1CPassword;
  handled := True;
  try
  c := ParamStr(1)[2];
  if length(Paramstr(1)) > 2 then
  option := copy(paramstr(1),3,length(paramstr(1))-1);
  Path := CakDir1.Grabtemppath;

  if paramcount > 1 then
  param1 := paramstr(2);
  if paramcount > 2 then
  param2 := paramstr(3);
  if paramcount > 3 then
  param3 := paramstr(4);

  CakDir1.AddOptions.add_usepath := (pos('d',option) <> 0);
  CakDir1.AddOptions.add_SubDir := (pos('s',option) <> 0);
  CakDir1.AddOptions.add_hidden := true;
  if not fileexists(param1) then
  CakDir1.New_Archive(param1) else
  CakDir1.Set_Archive_List(param1);
  CakDir1.List_Archive(0,CakDir1.Total_Archive -1);

  Writeln;
  case c of
  '?' : DisplayHelp;
  'a' : begin
        CakDir1.AddOptions.add_files.Clear;
        CakDir1.AddOptions.add_files.Add(param2);
        CakDir1.Add;
        end;
  'r' : begin
        CakDir1.Clear_Selected_List;
        Cakdir1.Mask_Add_Selected_List(param2,cakdir1.archive_list[0]._arcname);
        CakDir1.delete;
        end;

  else
      handled := False;
  end;

  finally
  CakDir1.free;
  result := handled;
  end;

end;


begin
        Writeln('Qzip Commandline Add/Delete Utility ' + VER);
        Writeln('Created by : Joseph Leung');
        Writeln('Compilied date : ' + lastedit);
        Writeln;
        Control1 := TControl1.Create(nil);
        if Paramcount > 0 then ProcessParam else
        DisplayHelp;
        Control1.free;
        Writeln;
        Writeln('Press <Enter> to continue');
        Readln;
end.