program Extract;
{$APPTYPE CONSOLE}
//{$R Extract.res}
uses
  CakDir,
  Classes,
  SysUtils,
  Controls;
const ver = '0.2';
      lastedit = '05/16/2001';
      fmtstr = '%-14s %-18s %-10s %-10s %-20s';
type
  TControl1 = class(TControl)
  private
    { Private declarations }
  public
  procedure CakDir1CMessage(Sender: TObject; ErrCode: Integer; Message: String);
  procedure CakDir1CProgress(Sender: TObject; Filename: String; FileSize, Completed: Integer);
  procedure CakDir1COverwrite( Sender : TObject; Filename : string;var overwrite : boolean ;var applytoall : boolean);
  procedure CakDir1CPassword( Sender : TObject; filename : string; var newpassword : string);
    { Public declarations }
  end;

var control1 : Tcontrol1;
procedure TControl1.CakDir1CPassword( Sender : TObject; filename : string; var newpassword : string);
begin
Write('Please enter the password of ' + Filename );
readln(newpassword);
end;

procedure TControl1.CakDir1COverwrite( Sender : TObject; Filename : string;var overwrite : boolean ;var applytoall : boolean);
var c : char;
begin
c := '-';
while (c <> 'Y') and (c <> 'N') and (c <> 'A') and (c <> 'C') do
begin
Writeln('Do you want to overwrite ' + Filename + '(Yes/No/All/Cancel)');
Readln(c);
applytoall := false;
case c of
'Y' : overwrite := true;
'N' : overwrite := false;
'A' : begin overwrite := true; applytoall := true; end;
'C' : begin overwrite := false; applytoall := true; end;
end;
end;

end;

procedure TControl1.CakDir1CMessage(Sender: TObject; ErrCode: Integer; Message: String);
begin
        Writeln(Message);
end;
procedure TControl1.CakDir1CProgress(Sender: TObject; Filename: String;  FileSize, Completed: Integer);
begin
        Write('.');
end;

procedure DisplayHelp;
var k : string;
    x : supporttype;
    CakDir1 : TCakDir;
begin
          CakDir1 := TCakDir.Create(nil);
          for x := _ZIP to _WIT do
                if cakdir1.CanDo(x,_LoadContents) then
                        if x <> _AKS then
                        if k = '' then
                        k := k + cakdir1.GetarcStringFull(x) else
                        k := k + ',' + cakdir1.GetarcStringFull(x);
          CakDir1.free;

          Writeln('Usage : extract.exe /[l,ft,fh] <Archive name>');
          Writeln('        extract.exe /[c,t][d,o] <Archive name> <File2Extract>');
          Writeln('        extract.exe /[e][d,o] <Archive name> <File2Extract> <Path>');
          Writeln('Archive supported :' + k);
          Writeln('e.g. extract /t c:\demo.zip ');
          Writeln('e.g. extract /eod c:\demo1.zip demo.* d:\temp');
          Writeln;
          Writeln('/? = display this help');
          Writeln('/c = extract file to current directory');
          Writeln('/e = extract file to last param');
          Writeln('/fh = html file list');
          Writeln('/ft = html file list');
          Writeln('/fp = pdf file list');
          Writeln('/t = test archive');
          Writeln('/l = list archive contents');
          Writeln('/x = text file list');
          Writeln;
          Writeln('o = Overwrite');
          Writeln('d = Use Default path');
end;

function ProcessParam: boolean;
var
  c:       char;
  k,option:     string;
  Path:    String;
  param1,param2,param3 : string;
  fn : string;
  handled: boolean;
  i:       integer;
  CakDir1 : TCakDir;
begin
  if (ParamStr(1)[1] <> '/') or (fileexists(Paramstr(1))) then
  begin
    Result := False;
    exit;
  end;

  CakDir1 := TCakDir.Create(nil);
  CakDir1.OnCMessage := control1.CakDir1CMessage;
  CakDir1.OnCProgress := Control1.CakDir1CProgress;
  CakDir1.OnCOverwrite := Control1.CakDir1COverwrite;
  CakDir1.OnCPassword := Control1.CakDir1CPassword;
  handled := True;
  try
  c := ParamStr(1)[2];
  if length(Paramstr(1)) > 2 then
  option := copy(paramstr(1),3,length(paramstr(1))-1);
  Path := CakDir1.Grabtemppath;

  if paramcount > 1 then
  param1 := paramstr(2);
  if paramcount > 2 then
  param2 := paramstr(3);
  if paramcount > 3 then
  param3 := paramstr(4);

  CakDir1.Extractoptions.extr_DirNames := (pos('d',option) <> 0);
  CakDir1.Extractoptions.extr_OverWrite := (pos('o',option) <> 0);
  CakDir1.Set_Archive_List(param1);
  CakDir1.List_Archive(0,CakDir1.Total_Archive -1);
  
  if c = '?' then
          DisplayHelp else
  begin
  if not fileexists(param1) then
        Writeln('- Not exists');

  if CakDir1.Archive_List[0]._ARCtype = _WIT then
        Writeln('-Unknown Format') else
        begin
        Writeln('- Type = ' + CakDir1.GetarcString(CakDir1.Archive_List[0]._ARCtype));
        Writeln('- Size = ' + CakDir1.SizeinK(CakDir1.Get_Total_Size));
        Writeln('- Total files = ' + inttostr(CakDir1.Total_Contents));
        end;
  end;
  Writeln;
  case c of
    't': begin   //test archive
         CakDir1.Clear_Archive_List;
         CakDir1.Test_Archive(0,CakDir1.Total_Archive-1);
         end;
    'e': begin   //extact file(s) to last param.
         CakDir1.Clear_Archive_List;
         k := param3;
         CakDir1.Extractoptions.extr_to := k;
         CakDir1.Clear_Selected_List;
         CakDir1.Mask_Add_Selected_List(param2,param1);
         CakDir1.extract;
         end;
    'c': begin
         CakDir1.Clear_Archive_List;
         CakDir1.Extractoptions.extr_to := Extractfilepath(param1);
         CakDir1.Clear_Selected_List;
         CakDir1.Mask_Add_Selected_List(param2,param1);
         CakDir1.extract;
         end;
    'f': begin
         if Option = 'h' then
         CakDir1.Filelist(_HTM,CakDir1.removefileext(param1) + '.htm',0,0)
         else if Option = 't' then
         CakDir1.Filelist(_TXT,CakDir1.removefileext(param1) + '.txt',0,0)
         else if Option = 'p' then
         CakDir1.Filelist(_PDF,CakDir1.removefileext(param1) + '.pdf',0,0);
         end;
    'l' :begin

         Writeln(Format(fmtstr,
         ['Filename','Type','Size','Date','Path']));
         Writeln(Format(fmtstr,
         ['--------','----','----','----','----']));
         for i := 0 to CakDir1.Total_Contents -1 do
         begin
         if CakDir1.archive_Contents[i]._Encrypted then
                fn := Uppercase(CakDir1.archive_Contents[i]._Filename) else
                fn := lowercase(CakDir1.archive_Contents[i]._Filename);
         Writeln(Format(fmtstr,
         [fn,
         CakDir1.archive_contents[i]._Filetype,
         CakDir1.sizeink(CakDir1.archive_contents[i]._Filesize),
         Datetostr(CakDir1.archive_contents[i]._Filetime),
         CakDir1.archive_contents[i]._Filedefpath
         ]));

         end;
         end;
    else
      handled := False;
  end;

  finally
  CakDir1.free;
  result := handled;
  end;

end;


begin
        Writeln('Qzip Commandline Extract Utility ' + VER);
        Writeln('Created by : Joseph Leung');
        Writeln('Compilied date : ' + lastedit);
        Writeln;
        Control1 := TControl1.Create(nil);
        if Paramcount > 0 then ProcessParam else
        DisplayHelp;
        Control1.free;
        Writeln;
        Writeln('Press <Enter> to continue');
        Readln;
end.