unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CakDir, StdCtrls, ExtCtrls, ComCtrls, CakListView;

type
  TForm1 = class(TForm)
    CakDir1: TCakDir;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Button4: TButton;
    Button5: TButton;
    CakListView1: TCakListView;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Edit2: TEdit;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    procedure Button1Click(Sender: TObject);
    procedure CakDir1CMessage(Sender: TObject; ErrCode: Integer;
      Message: String);
    procedure Button3Click(Sender: TObject);
    procedure CakDir1CProgress(Sender: TObject; Filename: String; FileSize,
      Completed: Integer);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CakListView1ColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure CakListView1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  accending : boolean;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var i : integer;
begin
        if opendialog1.Execute then
                begin

                        CakDir1.Clear_Archive_List;
                        CakDir1.Set_Archive_List(opendialog1.FileName);
                        CakDir1.List_Archive(i,i);
                        CakListView1.ReloadCAK;
                end;
end;

procedure TForm1.CakDir1CMessage(Sender: TObject; ErrCode: Integer;
  Message: String);
begin
        Memo1.Lines.Add(Message);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
        Memo1.Lines.clear;
        CakDir1.Test;
end;

procedure TForm1.CakDir1CProgress(Sender: TObject; Filename: String;
  FileSize, Completed: Integer);
begin
        Caption := Inttostr(FileSize) + '/' + Inttostr(Completed);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
        Memo1.Lines.clear;
        if CakDir1.Get_Selected_Count = 0 then
                CakDir1.Add_All_Selected_List;
        CakDir1.ExtractOptions.extr_to := Edit1.text;
        CakDir1.extract;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
        Cakdir1.stop := true;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
        Case CakListview1.ViewStyle of
        vsIcon : CakListview1.ViewStyle := vsList;
        vsList      : CakListview1.ViewStyle := vsReport;
        vsReport    : CakListview1.ViewStyle := vsSmallIcon;
        vsSmallIcon : CakListview1.ViewStyle := vsIcon;
        end;
end;

procedure TForm1.CakListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
        accending := not accending;
        Case Column.Index of
        0 : Cakdir1.Sort_Archive_List(accending,_FName);
        1 : Cakdir1.Sort_Archive_List(accending,_FType);
        2 : Cakdir1.Sort_Archive_List(accending,_FSize);
        3 : Cakdir1.Sort_Archive_List(accending,_FTime);
        4 : Cakdir1.Sort_Archive_List(accending,_FPSize);
        5 : Cakdir1.Sort_Archive_List(accending,_FRatio);
        6 : Cakdir1.Sort_Archive_List(accending,_FCRC);
        7 : Cakdir1.Sort_Archive_List(accending,_FDefPath);
        8 : Cakdir1.Sort_Archive_List(accending,_FArchive);
        end;
        CakListView1.ReloadCAK;
end;

procedure TForm1.CakListView1Click(Sender: TObject);
var i : integer;
    k : string;
begin

        for i := 0 to CakListview1.Items.Count -1 do
                begin
                if CakListview1.Items[i].Selected then
                        begin
                        k := CakListview1.Items[i].SubItems[6] + CakListview1.Items[i].Caption;
                        CakDir1.Add_Selected_List(k, CakListview1.Items[i].Subitems[7]);
                        end;

                end;
        Memo1.Lines.Add(Inttostr(CakDir1.Get_Selected_Count ) + ' files selected');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
        if opendialog1.execute then
        begin
        CakDir1.AddOptions.add_files.Clear;
        CakDir1.AddOptions.add_files.add(opendialog1.filename);
        CakDir1.addoptions.add_to := 1;
        CakDir1.Add;
        CakDir1.List_Archive(1,CakDir1.Total_Archive);
        CakListview1.ReloadCAK;
        end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
        CakDir1.Delete;
        CakDir1.List_Archive(1,CakDir1.Total_Archive);
        CakListview1.ReloadCAK;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
        Cakdir1.Filelist(_HTM,Edit2.text,1,CakDir1.Total_Archive);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
        CakDir1.ShowAgainDialog('^CAK^','Show again? ' + #10 + '(not saved...use regshowagaindialog instead)');
end;

procedure TForm1.Button10Click(Sender: TObject);
var b : boolean;
begin
        CakDir1.YesnoShowAgainDialog('^CAK^','Show again? ' + #10 + '(not saved...use regyesnoshowagaindialog instead)',b);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
        Form2.show;
end;

end.
