unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ComCtrls, CakTreeView, CakListView, CakDir;

type
  TForm1 = class(TForm)
    CakDir1: TCakDir;
    CakListView1: TCakListView;
    CAKTreeView1: TCAKTreeView;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    View1: TMenuItem;
    SmallIconview1: TMenuItem;
    Iconview1: TMenuItem;
    Listview1: TMenuItem;
    Reportview1: TMenuItem;
    Exit1: TMenuItem;
    Work1: TMenuItem;
    Extractselected1: TMenuItem;
    Deleteselected1: TMenuItem;
    Add1: TMenuItem;
    Memo1: TMemo;
    estarchive1: TMenuItem;
    Stop1: TMenuItem;
    ExtractAll1: TMenuItem;
    LoadScriptaks1: TMenuItem;
    About1: TMenuItem;
    Convertarchive1: TMenuItem;
    Close1: TMenuItem;
    StatusBar1: TStatusBar;
    Web1: TMenuItem;
    ZIPSFX1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure SmallIconview1Click(Sender: TObject);
    procedure Iconview1Click(Sender: TObject);
    procedure Listview1Click(Sender: TObject);
    procedure Reportview1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure CakListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Extractselected1Click(Sender: TObject);
    procedure Deleteselected1Click(Sender: TObject);
    procedure CakDir1CMessage(Sender: TObject; ErrCode: Integer;
      Message: String);
    procedure estarchive1Click(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure ExtractAll1Click(Sender: TObject);
    procedure LoadScriptaks1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Convertarchive1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Web1Click(Sender: TObject);
    procedure ZIPSFX1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Open1Click(Sender: TObject);
var atype : supporttype;
    k : string;
begin
        k := '';
        opendialog1.filter := '';
        for atype := _ZIP to _WIT do
        if atype <> _WIT then // What is that!? means unknown format.
        if atype <> _AKS then // Script...
        begin
        k := cakdir1.GetarcStringFilter(atype);
        opendialog1.filter := opendialog1.filter + cakdir1.GetarcString(atype) + 'archives (' + k + ') |' + k + '|';
        end;
        if opendialog1.Execute then
                begin
                cakdir1.ArchiveName := opendialog1.filename;
                Cakdir1.List_Archive(0,0);
                CakTreeview1.ReloadCAK;
                CakListview1.ReloadCAK;
                end;
        Statusbar1.SimpleText := Format('Archive have %d files size : %s',
                                [cakdir1.total_contents, cakdir1.sizeink(cakdir1.Get_Total_Size)]);
end;

procedure TForm1.SmallIconview1Click(Sender: TObject);
begin
        CakListview1.ViewStyle := vsSmallIcon;
end;

procedure TForm1.Iconview1Click(Sender: TObject);
begin
        CakListview1.ViewStyle := vsIcon;
end;

procedure TForm1.Listview1Click(Sender: TObject);
begin
        CakListview1.ViewStyle := vsList;
end;

procedure TForm1.Reportview1Click(Sender: TObject);
begin
        CakListview1.ViewStyle := vsReport;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
        Application.Terminate;
end;

procedure TForm1.CakListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var i : integer;
begin
        Cakdir1.Clear_Selected_List;
        for i := 0 to caklistview1.Items.Count -1 do
          if caklistview1.Items[i].Selected then
          with caklistview1.Items[i] do
          cakdir1.Add_Selected_List(SubItems.Strings[6] +
                        Caption, SubItems.Strings[7]);

        Statusbar1.SimpleText := Format('You have selected %d files size : %s',
                                [cakdir1.get_selected_count, cakdir1.sizeink(cakdir1.Get_Selected_Size)]);
end;

procedure TForm1.Extractselected1Click(Sender: TObject);
var k : string;
begin
        k := Inputbox('','Input path to extract :','');
        if k <> '' then
                begin
                cakdir1.Extractoptions.extr_to := k;
                cakdir1.Extractoptions.extr_DirNames := true;
                cakdir1.Extractoptions.extr_OverWrite := true;
                cakdir1.Extract;
                end;
end;

procedure TForm1.Deleteselected1Click(Sender: TObject);
begin
                cakdir1.Delete;
end;

procedure TForm1.CakDir1CMessage(Sender: TObject; ErrCode: Integer;
  Message: String);
begin
        memo1.lines.Add(Message);
end;

procedure TForm1.estarchive1Click(Sender: TObject);
begin
        cakdir1.Test;
end;

procedure TForm1.Add1Click(Sender: TObject);
var k : string;
begin
        k := Inputbox('','Enter file to add:','');
        if k <> '' then
                begin
                cakdir1.AddOptions.add_to := 0;
                cakdir1.AddOptions.add_SubDir := true;
                cakdir1.AddOptions.add_usepath := true;
                cakdir1.AddOptions.add_hidden := true;
                cakdir1.AddOptions.add_files.Add(k);
                cakdir1.AddOptions.add_relative := false;
                cakdir1.Add;
                end;

end;

procedure TForm1.Stop1Click(Sender: TObject);
begin
        Cakdir1.Stop := true;
end;

procedure TForm1.ExtractAll1Click(Sender: TObject);
var k : string;
begin
        k := Inputbox('','Input path to extract :','');
        if k <> '' then
                begin
                cakdir1.Add_All_Selected_List;
                cakdir1.Extractoptions.extr_to := k;
                cakdir1.Extractoptions.extr_DirNames := true;
                cakdir1.Extractoptions.extr_OverWrite := true;
                cakdir1.Extract;
                end;
end;


procedure TForm1.LoadScriptaks1Click(Sender: TObject);
var astrings : tstrings;
begin
        astrings := tstringlist.create();
        opendialog1.filter := 'AKS script (*.aks)|*.aks';
        if opendialog1.Execute then
                begin
                astrings.LoadFromFile(opendialog1.filename);
                cakdir1.Load_Script(astrings);
                end;
        astrings.free;
end;

procedure TForm1.About1Click(Sender: TObject);
var x : supporttype;
    k : string;
begin
        Memo1.lines.add('Common Archiver Kit Experinment Demo 2');
        k := '';
        for x := _ZIP to _WIT do
        if x <> _WIT then
        if x <> _AKS then
        if Cakdir1.Cando(x,_Extract) then
                if k = '' then
                k := Cakdir1.GetarcString(x) else
                k := k + ',' + Cakdir1.GetarcString(x);
        Memo1.lines.add('Extract support -' + k);

        k := '';
        for x := _ZIP to _WIT do
        if x <> _WIT then
        if x <> _AKS then
        if Cakdir1.Cando(x,_Add) then
                if k = '' then
                k := Cakdir1.GetarcString(x) else
                k := k + ',' + Cakdir1.GetarcString(x);
        Memo1.lines.add('Add support -' + k);

        k := '';
        for x := _ZIP to _WIT do
        if x <> _WIT then
        if x <> _AKS then
        if Cakdir1.Cando(x,_Extract) then
                if k = '' then
                k := Cakdir1.GetarcString(x) else
                k := k + ',' + Cakdir1.GetarcStringFULL(x);
        Memo1.lines.add('Extract support(full) -' + k);

        k := '';
        for x := _ZIP to _WIT do
        if x <> _WIT then
        if x <> _AKS then
        if Cakdir1.Cando(x,_Add) then
                if k = '' then
                k := Cakdir1.GetarcString(x) else
                k := k + ',' + Cakdir1.GetarcStringFULL(x);
        Memo1.lines.add('Add support(full) -' + k);


end;

procedure TForm1.Convertarchive1Click(Sender: TObject);
begin
        //You can verify if you can add file to CAB
        if cakdir1.Cando(_CAB,_ADD) then
        cakdir1.Archive_Convert(cakdir1.ArchiveName,_CAB);
        //Then Convert it...
        Showmessage('Convert as ' + cakdir1.removefileext(cakdir1.archivename) + '.cab');
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
        Cakdir1.Clear_Archive_List;
        CakTreeview1.ReloadCAK;
        CakListview1.ReloadCAK;
        Statusbar1.SimpleText := '';
end;

procedure TForm1.Web1Click(Sender: TObject);
begin
        cakdir1.runwww('http://qzip.cjb.net');
end;

procedure TForm1.ZIPSFX1Click(Sender: TObject);
begin
        cakdir1.sfxOptions.sfx_message := 'This is a demo sfx';
        cakdir1.sfxOptions.sfx_caption := 'DA SFX';
        cakdir1.sfxOptions.sfx_extractto := '><'; //temp folder;
        cakdir1.sfxoptions.sfx_to := 0;
        cakdir1.SFX;
end;

end.
